#
#  Spu eXtended Math library -- Diane Neisius (DNE) 3/2010
#


# unsigned int (64 bit) division/modulo by 32 bit with 32 bit result
# -- atomic function, needs no special care for stack --
#
#  R3: input high word vector / result vector at exit
#  R4: input low word vector
#  R5: input divisor word vector
#  R6: input result type choice: 1=mod, 0=div 
#
#  The algorithm basically is inspired by 'udivmodsi4' of libgcc (GPL'ed)

	.data
	.align 4
mask:
	.word	0x80000000, 0x80000000, 0x80000000, 0x80000000

	.text
	.align 4
	.global sxm_udivmod
	.type   sxm_udivmod, @function

sxm_udivmod:				# P  comment:
	il	$31, 1			# 0  R31 = bit_l
	il	$32, 0			# 0  R32 = bit_h; bit = 1
	il	$42, 0			# 0  R42 = den_h

	or	$43, $5, $5		# 0  R43 = den_l
	lqa	$75, mask		# 1
	il	$40, 0			# 0  R40 = res
	br	d_entry			# 1

loopd0:	
	ceq	$20, $31, $75		# 0  bit to shift out?
	andi	$20, $20, 1		# 0
	shli	$31, $31, 1		# 0
	shli	$32, $32, 1		# 0

	or	$32, $32, $20		# 0  bit <<= 1
	and	$20, $43, $75		# 0
	ceq	$20, $20, $75		# 0  bit to shift out?
	andi	$20, $20, 1		# 0

	shli	$43, $43, 1		# 0
	shli	$42, $42, 1		# 0
	or	$42, $42, $20		# 0  den <<= 1
	lnop				# 1
d_entry:
	clgt	$51, $3,  $42		# 0  R51 = (num_h > den_h)  [mask]
	ceq	$52, $3,  $42		# 0  R52 = (num_h == den_h) [mask]
	clgt    $53, $4,  $43		# 0  R53 = (num_l > den_l)  [mask]
	ceq	$54, $4,  $43		# 0  R54 = (num_l == den_l) [mask]

	or	$53, $53, $54		# 0  num_l >= den_l
	and	$53, $53, $52		# 0       ... && num_h == den_h
	or	$53, $53, $51		# 0       ... || numh > den_h
	lnop				# 1

	nop				# 0
	orx	$53, $53		# 1  is 1 as long as any component has num >= den
	nop				# 0
	brnz	$53, loopd0		# 1

loopd1:
	clgt	$51, $3,  $42		# 0  R51 = (num_h > den_h)  [mask]
	ceq	$52, $3,  $42		# 0  R52 = (num_h == den_h) [mask]
	clgt    $53, $4,  $43		# 0  R53 = (num_l > den_l)  [mask]
	ceq	$54, $4,  $43		# 0  R54 = (num_l == den_l) [mask]

	or	$53, $53, $54		# 0  num_l >= den_l
	and	$53, $53, $52		# 0       ... && num_h == den_h
	or	$51, $53, $51		# 0       ... || numh > den_h; R51 = final mask
	or	$70, $31, $32		# 0  still any bit in?

	ceqi	$70, $70, 0		# 0  R70 = !(op finished?)
	andc	$51, $51, $70		# 0  if op finished, mask R51 out
	and	$60, $51, $42		# 0  masked copy of den_h
	and	$61, $51, $43		# 0  masked copy of den_l

	and	$62, $51, $31		# 0  masked copy of bit_l
	sf	$66, $61, $4		# 0
	bg	$65, $61, $4		# 0
	sfx	$65, $60, $3		# 0
  
	or	$3,  $65, $65		# 0  num = num - den (masked)
	or	$4,  $66, $66		# 0
	or	$40, $40, $62		# 0  res = res || bit_l (masked)
	ori	$71, $70, -2		# 0 
 
	ai	$71, $71, 1		# 0  R71 = -shift mask (for rotm operations)
	andi	$72, $32, 1		# 0  start shift bit...
	ceqi	$72, $72, 1		# 0
	and	$72, $72, $75		# 0

	andc	$72, $72, $70		# 0  R72 = bit to shift out of bit_h
	rotm	$32, $32, $71		# 0
	rotm	$31, $31, $71		# 0
	or	$31, $31, $72		# 0  bit >>= 1 (masked)

	andi	$73, $42, 1		# 0  shift den...
	ceqi	$73, $73, 1 		# 0
	and	$73, $73, $75		# 0
	andc	$73, $73, $70		# 0  R73 = bit to shift out of den_h

	rotm	$42, $42, $71 		# 0
	lnop				# 1
	rotm	$43, $43, $71		# 0
	orx	$70, $70		# 1  R70 = overall finished?

	or	$43, $43, $73		# 0  den >>= 1 (masked)
	brz	$70, loopd1		# 1  if not finished, loop

					#    we pay 18 pipeline stall cycles here...

	ceqi	$72, $6,  0		# 0  R72 = !(op mask)
	lnop				# 1

	andc	$73, $4,  $72		# 0  on 0: num_l
	lnop				# 1
	and	$74, $40, $72		# 0  on 1: res
	lnop 				# 1

	or	$3,  $73, $74		# 0
	bi	$lr			# 1  return

