#
#  Spu eXtended Math library -- Diane Neisius (DNE) 3/2010
#


# unsigned int (32 bit) multiplication with 64 bit result
# -- atomic function, needs no special care for stack --
#
#  R3: ptr to result high word vector
#  R4: ptr to result low word vector
#  R5: input word vector a
#  R6: input word Vector b

	.data
	.align 4
mask:
	.byte	2, 3, 16, 17, 6, 7, 20, 21, 10, 11, 24, 25, 14, 15, 28, 29

	.text
	.align 4
	.global sxm_umul
	.type   sxm_umul, @function

sxm_umul:				# P  comment:

	il	$70, 0			# 0  R80 = const zero
	lqa	$30, mask		# 1  R30 = precalc'd shuffle mask
	mpyu	$20, $5,  $6		# 0  R20 = al * bl
	shufb	$21, $70, $5, $30	# 1

	mpyu	$21, $21, $6		# 0  R21 = ah * bl
	shufb	$22, $70, $6, $30	# 1	
	mpyu	$22, $22, $5		# 0  R22 = al * bh
	lnop				# 1 
 
	mpyhhu	$23, $5,  $6		# 0  R23 = ah * bh
	shufb	$33, $21, $70, $30	# 1  R33 = (ah * bl)l << 16
	a	$40, $20, $33		# 0
	shufb	$34, $22, $70, $30	# 1  R34 = (al * bh)l << 16

	cg	$41, $20, $33		# 0  R41 = carry1
	shufb	$31, $70, $21, $30	# 1  R31 = (ah * bl)h
	a	$42, $40, $34		# 0  R42 = result L
	shufb	$32, $70, $22, $30	# 1  R32 = (al * bh)h

	cg	$43, $40, $34		# 0  R43 = carry2
	stqd	$42, 0($4)		# 1  store result L
	addx	$43, $23, $31		# 0 
	lnop				# 1

	addx	$41, $43, $32		# 0  R41 = result H
	lnop				# 1  see below
	nop				# 0  prevent R41 collision here
	stqd	$41, 0($3)		# 1  store result H

	nop				# 0 
	bi	$lr			# 1  return



